/*
PrintIt Copyright (c) 2005-2006, Alexander R. Pruss
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

3. The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (
INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (
INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/
#ifndef _PRINTIT_H
#define _PRINTIT_H
#include "PrintProtocol.h"
#include "PrintIt_Res.h"

Boolean PrinterTestDriver( DriverType driver, void* data,
    ProtocolSendFunction SendFunction, UInt32 sendFunctionRef, Boolean dataMatters );

Boolean PrintScreenDriver( DriverType driver, void* data,
    ProtocolSendFunction SendFunction, UInt32 sendFunctionRef, Boolean dataMatters );


typedef struct {
    BitmapType* bitmap;
    UInt32      timeStamp;
    Boolean     big;
    Boolean     force600DPI;
} PrintScreenData;


typedef struct {
    PrinterDescriptor history[ NUM_HISTORY_ENTRIES ];
    UInt32            jobNumber;
    Boolean           doubleSize;
} PreferenceType;

#define DO_IMAGE     ( sysAppLaunchCmdCustomBase + 0 )

Boolean NetOpen( void );
void NetClose( void );
void NetCloseImmediate( void );
//Boolean Print( PreferenceType* p, BitmapType* bmp, UInt16 jobNumber );
void SavePrefs0( PreferenceType* p );
void LoadPrefs0( PreferenceType* p );
UInt8 GetPixel( Coord x, Coord y, UInt16 maxValue );

#define MemZero( p, n ) MemSet( p, n, 0 )

#endif
