/*
PrintIt Copyright (c) 2005-2006, Alexander R. Pruss
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

3. The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (
INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (
INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/
#include <stdio.h>

int main( int argc, char** argv )
{
    int i;
    int j;
    int row;
    int shade;
    int progress;
    int raster[ 4 ][ 4 ];

    int x[ 16 ];
    int y[ 16 ];

    for ( i = 0 ; i < 16 ; i++ ) {
        int x1;
        int y1;

        do {
            x1 = rand() % 4;
            y1 = rand() % 4;

            for ( j = 0 ; j < i ; j++ ) {
                 if ( x1 == x[ j ] && y1 == y[ j ] )
                     break;
            }
        } while ( j < i );

        x[ i ] = x1;
        y[ i ] = y1;
    }

    for ( i = 0 ; i < 4 ; i++ )
         for ( j = 0 ; j < 4 ; j++ )
              raster[ i ][ j ] = 0;


    printf( "typedef UInt8 DitherEntry16[ 4 ];\n" );
    printf( "DitherEntry16 dither16[ 16 ]= { \n" );
    for ( progress = shade = 0 ; shade < 16 ; progress++, shade++ ) {

        printf( "{ /* shade %d */ ", shade );

        for ( row = 0 ; row < 4 ; row++ ) {
             int value;
             int col;

             value = 0;

             for ( col = 0 ; col < 4 ; col++ ) {
                  if ( raster[ row ][ col ] ) {
                      value |= 1 << col;
                  }
             }

             printf( "0x%X, ", value );
        }

        printf( "},\n" );

        raster[ x[ progress ] ][ y[ progress ] ] = 1;
        if ( progress == 16 / 2 ) {
            progress++;
            raster[ x[ progress ] ][ y[ progress ] ] = 1;
        }
    }

    printf( "};\n" );

    return 0;
}
